TLayer< TPort > Class Template Reference

`#include <TLayer.hh>`

Inheritance diagram for TLayer< TPort >:

## Public Member Functions

| TLayer ()
| TLayer (const std::string &p_type)
void | addUpperPort (TPort *p_port)
void | removeUpperPort (TPort *)
Public Member Functions inherited from Layer
| Layer ()
| Type description, it indicates the protocol type (e.g. CAM, DENM, GN, ETH, PCAP...) More...
| Layer (const std::string &p_type)
| Specialized constructor Create a new instance of the Layer class with its type description. More...
virtual | ~Layer ()
| Default destructor. More...
void | deleteLayer ()
| Delete this layer. More...
void | addUpperLayer (Layer *p_layer)
| Add a new layer in the list of the upper layer. More...
void | removeUpperLayer (Layer *p_layer)
| Remove the specified upper layer protocol from the list of the upper layer. More...
virtual void | sendData (OCTETSTRING &p_data, Params &p_params)
| Send bytes formated data to the lower layers. More...
virtual void | receiveData (OCTETSTRING &p_data, Params &p_params)
| Receive bytes formated data from the lower layers. More...
const std::string & | to_string () const
| Remove the specified upper layer protocol from the list of the upper layer. More...

## Protected Member Functions

template<typename TMessage >
void | toAllUpperPorts (const TMessage &m, const Params &param)
Protected Member Functions inherited from Layer
void | toAllLayers (std::vector< Layer *> &layers, OCTETSTRING &data, Params &params)
void | receiveToAllLayers (OCTETSTRING &data, Params &params)
void | sendToAllLayers (OCTETSTRING &data, Params &params)

## Private Types

typedef std::vector< TPort * > | TPortList
typedef std::vector< TPort * >::iterator | TPortListIterator

## Private Attributes

TPortList | upperPorts

## Additional Inherited Members

Protected Attributes inherited from Layer
std::string | type
| List of the lower protocol layers. More...

## Member Typedef Documentation

## TPortList

template<typename TPort>

typedef std::vector<TPort*> TLayer< TPort >::TPortList

private

## TPortListIterator

template<typename TPort>

typedef std::vector<TPort*>::iterator TLayer< TPort >::TPortListIterator

private

## Constructor & Destructor Documentation

## TLayer() [1/2]

template<typename TPort>

TLayer< TPort >::TLayer | ( |  | ) |

inlineexplicit

## TLayer() [2/2]

template<typename TPort>

TLayer< TPort >::TLayer | ( | const std::string & | p_type | ) |

inlineexplicit

## Member Function Documentation

## addUpperPort()

template<typename TPort>

void TLayer< TPort >::addUpperPort | ( | TPort * | p_port | ) |

inline

## removeUpperPort()

template<typename TPort>

void TLayer< TPort >::removeUpperPort | ( | TPort * |  | ) |

## toAllUpperPorts()

template<typename TPort>
template<typename TMessage >

void TLayer< TPort >::toAllUpperPorts | ( | const TMessage & | m,
|  | const Params & | param
| ) |  |

inlineprotected

## Member Data Documentation

## upperPorts

template<typename TPort>

TPortList TLayer< TPort >::upperPorts

private

The documentation for this class was generated from the following file:

- /home/vagrant/TriesAndDelete/etsi_its/framework/include/TLayer.hh